"use strict";

exports.__esModule = true;
exports.useCommandBuilder = useCommandBuilder;

var _react = require("react");

var _useClient = require("./use-client");

var _generic = require("./generic");

function useCommandBuilder(builder, options, callback, dependencies) {
  var _firstOfType;

  var client = (0, _useClient.useClient)();
  var actualOptions = (0, _generic.firstOfType)(_generic.isOptions, options);
  var actualCallback = (0, _generic.firstOfType)(_generic.isCallback, options, callback);
  var actualDependencies = (_firstOfType = (0, _generic.firstOfType)(_generic.isDependencies, options, callback, dependencies)) != null ? _firstOfType : [builder, actualOptions, actualCallback].filter(function (i) {
    return i;
  });
  return (0, _react.useCallback)(function (data) {
    return client.command(builder(data), actualOptions, actualCallback);
  }, [client].concat(actualDependencies));
}
//# sourceMappingURL=use-command-builder.js.map